package live

import (
	"github.com/gin-gonic/gin"
	"live/app/common"
	"live/app/lib/back"
	"live/app/lib/tools"
	"live/app/logic/live"
)

type Praise struct {
}

type argsPraise struct {
	LiveItemId uint `json:"liveItemId" form:"liveItemId"`
	Praise     uint `json:"praise" form:"praise"`
}

// @Title 点赞
func (p *Praise) Add(c *gin.Context) {
	uid := common.GetUserId(c)
	if uid == 0 {
		back.Fail(c, "未登录")
		return
	}
	args := argsPraise{}
	if err := tools.ParseParams(&args, c); err != nil {
		back.Fail(c, err.Error())
		return
	}
	if args.LiveItemId <= 0 || args.Praise <= 0 {
		back.Fail(c, "参数错误")
		return
	}
	err := (&live.Praise{}).AddPraise(uid, args.LiveItemId, args.Praise)
	if err != nil {
		back.Fail(c, err.Error())
		return
	}
	back.Suc(c, "操作成功", "")
	return
}
