package live

import (
	"github.com/gin-gonic/gin"
	"live/app/lib/back"
	"live/app/lib/tools"
	"live/app/model/live"
)

type Report struct {
}

// @Title 举报类型
func (r *Report) Types(c *gin.Context) {
	liveReportTypes := (&live.LiveReportType{}).GetAll()
	back.Suc(c, "操作成功", liveReportTypes)
}

type argsSubmit struct {
	Type    uint   `json:"type" form:"type"`
	Content string `json:"content" form:"content"`
	ImgUrl  string `json:"imgUrl" form:"imgUrl"`
}

// @Title 举报
func (r *Report) Submit(c *gin.Context) {
	args := argsSubmit{}
	if err := tools.ParseParams(&args, c); err != nil {
		back.Fail(c, err.Error())
		return
	}
	if args.Type <= 0 || args.Content == "" {
		back.Fail(c, "参数错误")
		return
	}
	liveReportType := (&live.LiveReportType{}).GetById(args.Type)
	if liveReportType.Id <= 0 {
		back.Fail(c, "参数错误")
		return
	}
	data := live.LiveReport{
		Type:    args.Type,
		Content: args.Content,
		ImgUrl:  args.ImgUrl,
	}
	(&live.LiveReport{}).Create(&data)
	if data.Id <= 0 {
		back.Fail(c, "网络异常")
		return
	}
	back.Suc(c, "操作成功", nil)
}
