package grend

import (
	"github.com/gin-gonic/gin"
	"live/app/common"
	"live/app/lib/back"
	"live/app/lib/tools"
	"live/app/logic/user/trend"
)

type Praise struct {
}

type argsPraise struct {
	CommentId uint `json:"commentId" form:"commentId"`
}

// @Title 点赞
func (p *Praise) Add(c *gin.Context) {
	uid := common.GetUserId(c)
	if uid == 0 {
		back.Fail(c, "未登录")
		return
	}
	args := argsPraise{}
	if err := tools.ParseParams(&args, c); err != nil {
		back.Fail(c, err.Error())
		return
	}
	if args.CommentId <= 0 {
		back.Fail(c, "参数错误")
		return
	}
	err := (&trend.Comment{}).AddPraise(uid, args.CommentId)
	if err != nil {
		back.Fail(c, err.Error())
		return
	}
	back.Suc(c, "操作成功", "")
	return
}

// @Title 取消点赞
func (p *Praise) Cancel(c *gin.Context) {
	uid := common.GetUserId(c)
	if uid == 0 {
		back.Fail(c, "未登录")
		return
	}
	args := argsPraise{}
	if err := tools.ParseParams(&args, c); err != nil {
		back.Fail(c, err.Error())
		return
	}
	if args.CommentId <= 0 {
		back.Fail(c, "参数错误")
		return
	}
	err := (&trend.Comment{}).CancelPraise(uid, args.CommentId)
	if err != nil {
		back.Fail(c, err.Error())
		return
	}
	back.Suc(c, "操作成功", "")
	return
}
