package tencent

import (
	"math/rand"
	"sync"
	"time"
)

var Worker *worker

type worker struct {
	sync.Mutex
	timestamp int64
	number    uint32
	randNum   uint32
}

func init() {
	rand.Seed(time.Now().UnixNano())
	Worker = &worker{
		randNum: rand.Uint32(),
	}
}

// 获取1秒内不重复的随机数
func (w *worker) Rander() uint32 {
	w.Lock()
	defer w.Unlock()
	now := time.Now().Unix()
	if now == w.timestamp {
		w.number++
	} else {
		w.number = 0
		w.timestamp = now
		w.randNum = rand.Uint32()
	}
	return w.randNum ^ w.number
}
