package live

import (
	"github.com/golangkit/formatime"
	"gorm.io/gorm"
	"live/app/lib/db"
)

type LiveImProvisional struct {
	db.BaseModel
	Id         uint             `gorm:"column:id" json:"id"`
	Identifier string           `gorm:"column:identifier" json:"identifier"`
	CreatedAt  formatime.Second `gorm:"column:created_at" json:"createdAt"`
	UpdatedAt  formatime.Second `gorm:"column:updated_at" json:"updatedAt"`
	Count      uint             `gorm:"column:count" json:"count"`
}

// 插入
func (u *LiveImProvisional) Create(liveImProvisional *LiveImProvisional) uint {
	u.GetDb().Model(u).Create(liveImProvisional)
	if liveImProvisional.Id > 0 {
		return liveImProvisional.Id
	}
	return 0
}

// @Title 获取临时im账号
func (u *LiveImProvisional) GetByUserId() (result LiveImProvisional) {
	u.GetDb().Model(u).Order("updated_at").First(&result)
	return
}

// @Title 更新统计
func (u *LiveImProvisional) UpdateCount(query interface{}, args ...interface{}) int64 {
	return u.GetDb().Model(u).Where(query, args...).Update("count", gorm.Expr("count + 1")).RowsAffected
}
