package live

import (
	"github.com/golangkit/formatime"
	"live/app/lib/db"
)

type LiveRoom struct {
	db.BaseModel
	Id         uint             `gorm:"column:id" json:"id"`
	UserId     uint             `gorm:"column:user_id" json:"userId"`
	GroupId    string           `gorm:"column:group_id" json:"groupId"`
	StreamName string           `gorm:"column:stream_name" json:"streamName"`
	CreatedAt  formatime.Second `gorm:"column:created_at" json:"createdAt"`
	UpdatedAt  formatime.Second `gorm:"column:updated_at" json:"updatedAt"`
}

// 插入
func (l *LiveRoom) Create(liveRoom *LiveRoom) uint {
	l.GetDb().Create(liveRoom)
	if liveRoom.Id > 0 {
		return liveRoom.Id
	}
	return 0
}

func (l *LiveRoom) GetLiveByUserId(userId uint) (result LiveRoom) {
	if userId <= 0 {
		return
	}
	l.GetDb().First(&result, "user_id = ?", userId)
	return
}

func (l *LiveRoom) GetLiveById(id uint) (result LiveRoom) {
	if id <= 0 {
		return
	}
	l.GetDb().First(&result, "id = ?", id)
	return
}
