package middleware

import (
	"github.com/gin-gonic/gin"
	"io/ioutil"
	"live/app/lib/back"
	"live/app/lib/secure"
	"strings"
)

func Decrypt() gin.HandlerFunc {
	return func(c *gin.Context) {
		if c.Request.Method == "POST" &&
			strings.Contains(c.Request.Header.Get("Content-Type"), "application/json") &&
			!strings.Contains(c.Request.URL.Path, "callback") {
			b, _ := ioutil.ReadAll(c.Request.Body)
			if len(b) == 0 {
				c.Set("recook", nil)
			} else {
				body, err := secure.Decrypt(b)
				if err != nil {
					back.Err(c, err.Error())
					c.Abort()
					return
				}
				c.Set("recook", body)
			}
		}
		c.Next()
	}
}
